#ifndef	QUEUE_SEEN
#define QUEUE_SEEN

struct Configuration;

/* A Queue is a linked list implementation of a queue, used for BFS. */

typedef struct Queue
{
	struct ConfigurationList 	*head;		/* the configuration that will be dequeued next */
	struct ConfigurationList 	*tail;		/* the configuration that was just enqueued		*/
} Queue;


void 	InitQueue(Queue *queue);
void	DeleteQueue(Queue *queue);

void 	Enqueue(Queue *queue, struct Configuration *config);
struct Configuration 	*Dequeue(Queue *queue);

int		IsEmpty(Queue *queue);
int		IsInQueue(Queue *queue, struct Configuration *match);

#endif
